SystemOrganization addCategory: #TpTraits!
SystemOrganization addCategory: #'TpTraits-Test'!

Trait named: #Coleccion
	uses: {}
	category: 'TpTraits'!

!Coleccion commentStamp: '<historical>' prior: 0!
metodos de una lista generica
!

!Coleccion methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:13'!
coleccion
	^self requirements! !

!Coleccion methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:13'!
coleccion:unaColeccion
	^self requirements! !

!Coleccion methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:16'!
tamao
	^self coleccion size.! !

Trait named: #Estadistica
	uses: {}
	category: 'TpTraits'!

!Estadistica commentStamp: '<historical>' prior: 0!
An Estadistica is a Trait that contains methods which implement stats
!

!Estadistica methodsFor: 'as yet unclassified' stamp: 'fedecasares 9/5/2013 15:56'!
promedio
! !

TestCase subclass: #TestAlumno
	instanceVariableNames: 'alumno cursada curso1 materia1 materia2 materia3 carrera1 docente1 curso2 curso3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits-Test'!

!TestAlumno methodsFor: 'as yet unclassified' stamp: 'fedecasares 9/5/2013 16:29'!
setUp
	alumno:= Alumno new.
	cursada:= Cursada new.
	carrera1 := Carrera new.
	materia1 := Materia  new.
	materia2  := Materia  new.
	materia3  := Materia  new.
	curso1 := Curso new.
	curso2 := Curso new.
	curso3 := Curso new.
	docente1 := Docente new.
	
	alumno mat_terminadas: Bag new.
	alumno mat_abandonadas: Bag new.	
	alumno cursada: cursada.
	alumno carrera: carrera1.
	
	! !

Object subclass: #Alumno
	uses: Estadistica
	instanceVariableNames: 'carrera materias_terminadas materias_abandonadas cursadas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Alumno commentStamp: '<historical>' prior: 0!
An Alumno is xxxxxxxxx.

Instance Variables
!

Alumno class
	uses: Estadistica classTrait
	instanceVariableNames: ''!

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
carrera
	^ carrera! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
carrera: anObject
	carrera := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:54'!
cursadas
	^ cursadas! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:54'!
cursadas: anObject
	cursadas := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
materias_abandonadas
	^ materias_abandonadas! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
materias_abandonadas: anObject
	materias_abandonadas := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
materias_terminadas
	^ materias_terminadas! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
materias_terminadas: anObject
	materias_terminadas := anObject! !

Object subclass: #Carrera
	uses: Coleccion
	instanceVariableNames: 'nombre materias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Carrera commentStamp: '<historical>' prior: 0!
A Carrera is xxxxxxxxx.

Instance Variables
	materias:		<Object>

materias
	- xxxxx
!

Carrera class
	uses: Coleccion classTrait
	instanceVariableNames: ''!

!Carrera methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:18'!
coleccion
	^ materias .! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:18'!
coleccion:unaColeccion
	materias := unaColeccion .! !

!Carrera methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:24'!
nombre
	^ nombre! !

!Carrera methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:24'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Cursada
	instanceVariableNames: 'curso nota materia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Cursada commentStamp: '<historical>' prior: 0!
A Cursada is xxxxxxxxx.

Instance Variables
	curso:		<Object>
	materia:		<Object>
	nota:		<Object>

curso
	- xxxxx

materia
	- xxxxx

nota
	- xxxxx
!

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
curso
	^ curso! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
curso: anObject
	curso := anObject! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
materia
	^ materia! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
materia: anObject
	materia := anObject! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
nota
	^ nota! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
nota: anObject
	nota := anObject! !

Object subclass: #Curso
	uses: Coleccion
	instanceVariableNames: 'codigo cuatrimestre ao docentes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Curso commentStamp: '<historical>' prior: 0!
A Curso is xxxxxxxxx.

Instance Variables
!

Curso class
	uses: Coleccion classTrait
	instanceVariableNames: ''!

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:29'!
ao
	^ ao! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:29'!
ao: anObject
	ao := anObject! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:24'!
codigo
	^ codigo! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:24'!
codigo: anObject
	codigo := anObject! !

!Curso methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:20'!
coleccion
	^ docentes .! !

!Curso methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:20'!
coleccion:unaColeccion
	docentes := unaColeccion .! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:29'!
cuatrimestre
	^ cuatrimestre! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:29'!
cuatrimestre: anObject
	cuatrimestre := anObject! !

Object subclass: #Docente
	instanceVariableNames: 'nombre cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Docente commentStamp: '<historical>' prior: 0!
A Docente is xxxxxxxxx.

Instance Variables
!

!Docente methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:41'!
cursos
	^ cursos! !

!Docente methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:41'!
cursos: anObject
	cursos := anObject! !

!Docente methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:22'!
nombre
	^ nombre! !

!Docente methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:22'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Materia
	uses: Coleccion
	instanceVariableNames: 'nombre cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Materia commentStamp: '<historical>' prior: 0!
A Materia is xxxxxxxxx.

Instance Variables
	cursos:		<Object>

cursos
	- xxxxx
!

Materia class
	uses: Coleccion classTrait
	instanceVariableNames: ''!

!Materia methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:15'!
coleccion
	^cursos ! !

!Materia methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:16'!
coleccion:unaColeccion
	cursos := unaColeccion .! !

!Materia methodsFor: 'as yet unclassified' stamp: 'fedecasares 9/5/2013 16:55'!
cursos
	^cursos ! !

!Materia methodsFor: 'as yet unclassified' stamp: 'fedecasares 9/5/2013 16:55'!
cursos:unaColeccion
	cursos := unaColeccion .! !

!Materia methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:23'!
nombre
	^ nombre! !

!Materia methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:23'!
nombre: anObject
	nombre := anObject! !
